Index: branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90
===================================================================
--- branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 2370)
+++ branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 2371)
@@ -347,447 +351,222 @@
       !
    END SUBROUTINE ldf_slp
-
+   
 
    SUBROUTINE ldf_slp_grif ( kt )
-     !!----------------------------------------------------------------------
-     !!                 ***  ROUTINE ldf_slp_grif  ***
-     !!
-     !! ** Purpose :   Compute the squared slopes of neutral surfaces (slope
-     !!      of iso-pycnal surfaces referenced locally) ('key_traldfiso')
-     !!      at W-points using the Griffies quarter-cells.  Also calculates
-     !!      alpha and beta at T-points for use in the Griffies isopycnal
-     !!      scheme.
-     !!
-     !! ** Method  :   The slope in the i-direction is computed at U- and
-     !!      W-points (uslp, wslpi) and the slope in the j-direction is
-     !!      computed at V- and W-points (vslp, wslpj).
-     !!
-     !! ** Action : - alpha, beta
-     !!               wslp2 squared slope of neutral surfaces at w-points.
-     !!----------------------------------------------------------------------
-     USE oce, zdit  => ua   ! use ua as workspace
-     USE oce, zdis  => va   ! use va as workspace
-     USE oce, zdjt  => ta   ! use ta as workspace
-     USE oce, zdjs  => sa   ! use sa as workspace
-     !!
-     INTEGER, INTENT( in ) ::   kt         ! ocean time-step index
-     !!
-     INTEGER  ::   ji, jj, jk, ip, jp, kp  ! dummy loop indices
-     INTEGER  ::   iku, ikv                ! local integer
-     REAL(wp) ::   zt, zs, zh, zt2, zsp5, zp1t1           ! local scalars
-     REAL(wp) ::     zdenr, zrhotmp, zdndt, zdddt         !   -      -
-     REAL(wp) ::     zdnds, zddds, znum, zden             !   -      -
-     REAL(wp) ::     zslope, za_sxe, zslopec, zdsloper    !   -      -
-     REAL(wp) ::     zfact, zepsln, zatempw,zatempu,zatempv    !   -      -
-     REAL(wp) ::     ze1ur, ze2vr, ze3wr, zdxt, zdxs, zdyt, zdys, zdzt, zdzs, zvolf 
-     REAL(wp) ::     zr_slpmax, zdxrho, zdyrho, zabs_dzrho
-     REAL(wp), DIMENSION(jpi,jpj,jpk,0:1,0:1) ::   zsx,zsy
-     REAL(wp), DIMENSION(jpi,jpj    ,0:1,0:1) ::   zsx_ml_base, zsy_ml_base
-     REAL(wp), DIMENSION(jpi,jpj,jpk)         ::   zdkt, zdks
-     REAL(wp), DIMENSION(jpi,jpj) ::   zr_ml_basew
-     !!----------------------------------------------------------------------
-
-     ! 0. Local constant initialization
-     ! --------------------------------
-     zr_slpmax = 1.0_wp/slpmax
-
-     ! zslopec=0.004
-     ! zdsloper=1000.0
-     zepsln=1e-25
-
-     SELECT CASE ( nn_eos )
-
-     CASE ( 0 )               ! Jackett and McDougall (1994) formulation
-
-        !                                                ! ===============
-        DO jk = 1, jpk                                   ! Horizontal slab
-           !                                             ! ===============
-           DO jj = 1, jpjm1
-              DO ji = 1, fs_jpim1
-                 zt = tb(ji,jj,jk)          ! potential temperature
-                 zs = sb(ji,jj,jk) - 35.0   ! salinity anomaly (s-35)
-                 zh = fsdept(ji,jj,jk)      ! depth in meters
-
-                 beta(ji,jj,jk) = ( ( -0.415613e-09 * zt + 0.555579e-07 ) * zt      &
-                      &                            - 0.301985e-05 ) * zt      &
-                      &   + 0.785567e-03                                      &
-                      &   + (     0.515032e-08 * zs                           &
-                      &         + 0.788212e-08 * zt - 0.356603e-06 ) * zs     &
-                      &   +(  (   0.121551e-17 * zh                           &
-                      &         - 0.602281e-15 * zs                           &
-                      &         - 0.175379e-14 * zt + 0.176621e-12 ) * zh     &
-                      &                             + 0.408195e-10   * zs     &
-                      &     + ( - 0.213127e-11 * zt + 0.192867e-09 ) * zt     &
-                      &                             - 0.121555e-07 ) * zh
-
-                 alpha(ji,jj,jk) = - beta(ji,jj,jk) *                       &
-                      &     (((( - 0.255019e-07 * zt + 0.298357e-05 ) * zt   &
-                      &                               - 0.203814e-03 ) * zt   &
-                      &                               + 0.170907e-01 ) * zt   &
-                      &   + 0.665157e-01                                      &
-                      &   +     ( - 0.678662e-05 * zs                         &
-                      &           - 0.846960e-04 * zt + 0.378110e-02 ) * zs   &
-                      &   +   ( ( - 0.302285e-13 * zh                         &
-                      &           - 0.251520e-11 * zs                         &
-                      &           + 0.512857e-12 * zt * zt           ) * zh   &
-                      &           - 0.164759e-06 * zs                         &
-                      &        +(   0.791325e-08 * zt - 0.933746e-06 ) * zt   &
-                      &                               + 0.380374e-04 ) * zh)
-
-              END DO
-           END DO
-        END DO
-
-     CASE ( 1 )
-
-        alpha(:,:,:)=-rn_alpha
-        beta(:,:,:)=0.0
-
-     CASE ( 2 )
-
-        alpha(:,:,:)=-rn_alpha
-        beta (:,:,:)=rn_beta
-
-     CASE ( 3 )
-
-        DO jk =1, jpk
-           DO jj = 1, jpjm1
-              DO ji = 1, fs_jpim1
-                 zt = tb(ji,jj,jk)
-                 zs = sb(ji,jj,jk)
-                 zh = fsdept(ji,jj,jk)
-                 zt2 = zt**2
-                 zsp5 = sqrt(ABS(zs))
-                 zp1t1=zh*zt
-                 znum=9.99843699e+02+zt*(7.35212840e+00+zt*(-5.45928211e-02+3.98476704e-04*zt)) &
-                      +zs*(2.96938239e+00-7.23268813e-03*zt+2.12382341e-03*zs)  &
-                      +zh*(1.04004591e-02+1.03970529e-07*zt2+5.18761880e-06*zs+ &
-                      zh*(-3.24041825e-08-1.23869360e-11*zt2))
-                 zden=1.00000000e+00+zt*(7.28606739e-03+zt*(-4.60835542e-05+zt*(3.68390573e-07+zt*1.80809186e-10))) &
-                      +zs*(2.14691708e-03+zt*(-9.27062484e-06-1.78343643e-10*zt2)+zsp5*(4.76534122e-06+1.63410736e-09*zt2)) &
-                      + zh*(5.30848875e-06+zh*zt*(-3.03175128e-16*zt2-1.27934137e-17*zh))
-                 zdenr=1.0/zden
-                 zrhotmp=znum*zdenr
-                 zdndt=7.35212840e+00+zt*(-1.091856422e-01+1.195430112e-03*zt)-7.23268813e-03*zs &
-                      +zp1t1*(2.07941058e-07-2.4773872e-11*zh)
-                 zdddt=7.28606739e-03+zt*(-9.21671084e-05+zt*(1.105171719e-06+7.23236744e-10*zt))  &
-                      +zs*(-9.27062484e-06+zt*(-5.35030929e-10*zt+3.26821472e-09*zsp5))  &
-                      +zh*zh*(-9.09525384e-16*zt2-1.27934137e-17*zh)
-                 zdnds=2.96938239e+00-7.23268813e-03*zt+2*2.12382341e-03*zs+5.18761880e-06*zh
-                 zddds=2.14691708e-03+zt*(-9.27062484e-06-1.78343643e-10*zt2)+zsp5*(7.14801183e-06+2.45116104e-09*zt2)
-                 alpha(ji,jj,jk)=(zdndt-zrhotmp*zdddt)*zdenr
-                 beta(ji,jj,jk)=zdenr*(zdnds-zrhotmp*zddds)
-
-              END DO
-           END DO
-        END DO
-
-     CASE DEFAULT
-
-        IF(lwp) WRITE(numout,cform_err)
-        IF(lwp) WRITE(numout,*) '          bad flag value for nn_eos = ', nn_eos
-        nstop = nstop + 1
-
-     END SELECT
-
-     CALL lbc_lnk( alpha, 'T', 1. )
-     CALL lbc_lnk( beta, 'T', 1. )
-
-
-     ! ---------------------------------------
-     ! 1. Horizontal tracer gradients at T-level jk
-     ! ---------------------------------------
-     DO jk = 1, jpkm1
-        DO jj = 1, jpjm1
-           DO ji = 1, fs_jpim1   ! vector opt.
-              ! i-gradient of T and S at jj
-              zdit (ji,jj,jk) = ( tb(ji+1,jj,jk)-tb(ji,jj,jk) ) * umask(ji,jj,jk)
-              zdis (ji,jj,jk) = ( sb(ji+1,jj,jk)-sb(ji,jj,jk) ) * umask(ji,jj,jk)
-              ! j-gradient of T and S at jj
-              zdjt (ji,jj,jk) = ( tb(ji,jj+1,jk)-tb(ji,jj,jk) ) * vmask(ji,jj,jk)
-              zdjs (ji,jj,jk) = ( sb(ji,jj+1,jk)-sb(ji,jj,jk) ) * vmask(ji,jj,jk)
-           END DO
-        END DO
-     END DO
-
-     IF( ln_zps ) THEN      ! partial steps correction at the last level
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE ldf_slp_grif  ***
+      !!
+      !! ** Purpose :   Compute the squared slopes of neutral surfaces (slope
+      !!      of iso-pycnal surfaces referenced locally) (ln_traldf_grif=T)
+      !!      at W-points using the Griffies quarter-cells.  
+      !!
+      !! ** Method  :   calculates alpha and beta at T-points 
+      !!
+      !! ** Action : - triadi_g, triadj_g   T-pts i- and j-slope triads relative to geopot. (used for eiv)
+      !!             - triadi , triadj    T-pts i- and j-slope triads relative to model-coordinate
+      !!             - wslp2              squared slope of neutral surfaces at w-points.
+      !!----------------------------------------------------------------------
+      USE oce,   zdit  => ua   ! use ua as workspace
+      USE oce,   zdis  => va   ! use va as workspace
+      USE oce,   zdjt  => ta   ! use ta as workspace
+      USE oce,   zdjs  => sa   ! use sa as workspace
+      !!
+      INTEGER, INTENT( in ) ::   kt         ! ocean time-step index
+      !!
+      INTEGER  ::   ji, jj, jk, jl, ip, jp, kp  ! dummy loop indices
+      INTEGER  ::   iku, ikv                ! temporary integer
+      REAL(wp) ::   zfacti, zfactj, zatempw,zatempu,zatempv   ! local scalars
+      REAL(wp) ::   zbu, zbv, zbti, zbtj
+      REAL(wp) ::   zdxrho_raw, zti_coord, zti_raw, zti_lim, zti_lim2, zti_g_raw, zti_g_lim
+      REAL(wp) ::   zdyrho_raw, ztj_coord, ztj_raw, ztj_lim, ztj_lim2, ztj_g_raw, ztj_g_lim
+      REAL(wp) ::   zdzrho_raw
+      REAL(wp), DIMENSION(jpi,jpj,jpk,0:1) ::   zdzrho, zdyrho, zdxrho     ! Horizontal and vertical density gradients
+      REAL(wp), DIMENSION(jpi,jpj,0:1,0:1) ::   zti_mlb, ztj_mlb
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     ::   zdkt, zdks
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     ::   zalpha, zbeta       ! alpha, beta at T points, at depth fsgdept
+      REAL(wp), DIMENSION(jpi,jpj)         ::   z1_mlbw
+      !!----------------------------------------------------------------------
+
+      !--------------------------------!
+      !  Some preliminary calculation  !
+      !--------------------------------!
+      !
+      CALL eos_alpbet( tsb, zalpha, zbeta )     !==  before thermal and haline expension coeff. at T-points  ==!
+      !
+      DO jk = 1, jpkm1                          !==  before lateral T & S gradients at T-level jk  ==!
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1   ! vector opt.
+               zdit(ji,jj,jk) = ( tb(ji+1,jj,jk) - tb(ji,jj,jk) ) * umask(ji,jj,jk)    ! i-gradient of T and S at jj
+               zdis(ji,jj,jk) = ( sb(ji+1,jj,jk) - sb(ji,jj,jk) ) * umask(ji,jj,jk)
+               zdjt(ji,jj,jk) = ( tb(ji,jj+1,jk) - tb(ji,jj,jk) ) * vmask(ji,jj,jk)    ! j-gradient of T and S at jj
+               zdjs(ji,jj,jk) = ( sb(ji,jj+1,jk) - sb(ji,jj,jk) ) * vmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      IF( ln_zps ) THEN                               ! partial steps: correction at the last level
 # if defined key_vectopt_loop
-     DO jj = 1, 1
-        DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
+         DO jj = 1, 1
+            DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
 # else
-           DO jj = 1, jpjm1
-              DO ji = 1, jpim1
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
 # endif
-                 ! last ocean level
-                 iku  = MIN( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1
-                 ikv  = MIN( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1
-                 ! i-gradient of T and S
-                 zdit (ji,jj,iku) = gtsu(ji,jj,jp_tem)
-                 zdis (ji,jj,iku) = gtsu(ji,jj,jp_sal)
-                 ! j-gradient of T and S
-                 zdjt (ji,jj,ikv) = gtsv(ji,jj,jp_tem)
-                 zdjs (ji,jj,ikv) = gtsv(ji,jj,jp_sal)
-              END DO
-           END DO
-        ENDIF
-
-        ! ---------------------------------------
-        ! 1. Vertical tracer gradient at w-level jk
-        ! ---------------------------------------
-        DO jk = 2, jpk
-           zdkt(:,:,jk) = ( tb(:,:,jk-1) - tb(:,:,jk) ) * tmask(:,:,jk)
-           zdks(:,:,jk) = ( sb(:,:,jk-1) - sb(:,:,jk) ) * tmask(:,:,jk)
-        END DO
-
-        zdkt(:,:,1) = 0.0
-        zdks(:,:,1) = 0.0
-
-        ! ---------------------------------------
-        ! Depth of the w-point below ML base
-        ! ---------------------------------------
-        DO jj = 1, jpj
-           DO ji = 1, jpi
-              jk = nmln(ji,jj)
-              zr_ml_basew(ji,jj)=1.0/fsdepw(ji,jj,jk+1)
-           END DO
-        END DO
-
-
-        wslp2(:,:,:)=0.0
-        tfw(:,:,:) = 0.0
-        sfw(:,:,:) = 0.0
-        ftu(:,:,:) = 0.0
-        fsu(:,:,:) = 0.0
-        ftv(:,:,:) = 0.0
-        fsv(:,:,:) = 0.0
-        ftud(:,:,:) = 0.0
-        fsud(:,:,:) = 0.0
-        ftvd(:,:,:) = 0.0
-        fsvd(:,:,:) = 0.0
-        psix_eiv(:,:,:) = 0.0
-        psiy_eiv(:,:,:) = 0.0
-
-        ! ----------------------------------------------------------------------
-        ! x-z plane
-        ! ----------------------------------------------------------------------
-
-        ! calculate limited triad x-slopes zsx in interior (1=<jk=<jpk-1)
-        DO ip=0,1
-           DO kp=0,1
-
-              DO jk = 1, jpkm1
-                 DO jj = 1, jpjm1
-                    DO ji = 1, fs_jpim1   ! vector opt.
-
-                       ze1ur=1.0/e1u(ji,jj)
-                       zdxt=zdit(ji,jj,jk)*ze1ur
-                       zdxs=zdis(ji,jj,jk)*ze1ur
-
-                       ze3wr=1.0/fse3w(ji+ip,jj,jk+kp)
-                       zdzt=zdkt(ji+ip,jj,jk+kp)*ze3wr
-                       zdzs=zdks(ji+ip,jj,jk+kp)*ze3wr
-                       ! Calculate the horizontal and vertical density gradient
-                       zdxrho = alpha(ji+ip,jj,jk)*zdxt+beta(ji+ip,jj,jk)*zdxs
-                       zabs_dzrho = ABS(alpha(ji+ip,jj,jk)*zdzt+beta(ji+ip,jj,jk)*zdzs)+zepsln
-                       ! Limit by slpmax, and mask by psi-point
-                       zsx(ji+ip,jj,jk,1-ip,kp) = umask(ji,jj,jk+kp) &
-                            & *zdxrho/MAX(zabs_dzrho,zr_slpmax*ABS(zdxrho))
-                    END DO
-                 END DO
-              END DO
-
-           END DO
-        END DO
-
-        ! calculate slope of triad immediately below mixed-layer base
-        DO ip=0,1
-           DO kp=0,1
-              DO jj = 1, jpjm1
-                 DO ji = 1, fs_jpim1
-                    jk = nmln(ji+ip,jj)
-                    zsx_ml_base(ji+ip,jj,1-ip,kp)=zsx(ji+ip,jj,jk+1-kp,1-ip,kp)
-                 END DO
-              END DO
-           END DO
-        END DO
-
-        ! Below ML use limited zsx as is
-        ! Inside ML replace by linearly reducing zsx_ml_base towards surface
-        DO ip=0,1
-           DO kp=0,1
-
-              DO jk = 1, jpkm1
-
-                 DO jj = 1, jpjm1
-
-                    DO ji = 1, fs_jpim1   ! vector opt.
-                       ! k index of uppermost point(s) of triad is jk+kp-1
-                       ! must be .ge. nmln(ji,jj) for zfact=1.
-                       !                   otherwise  zfact=0.
-                       zfact = 1 - 1/(1 + (jk+kp-1)/nmln(ji+ip,jj))
-                       zsx(ji+ip,jj,jk,1-ip,kp) = zfact*zsx(ji+ip,jj,jk,1-ip,kp) + &
-                            & (1.0_wp-zfact)*(fsdepw(ji+ip,jj,jk+kp)*zr_ml_basew(ji+ip,jj))*zsx_ml_base(ji+ip,jj,1-ip,kp) 
-                    END DO
-
-                 END DO
-
-              END DO
-           END DO
-        END DO
-
-        ! Use zsx to calculate fluxes and save averaged slopes psix_eiv at psi-points
-        DO ip=0,1
-           DO kp=0,1
-
-              DO jk = 1, jpkm1
-
-                 DO jj = 1, jpjm1
-
-                    DO ji = 1, fs_jpim1   ! vector opt.
-
-                       ze1ur=1.0/e1u(ji,jj)
-                       zdxt=zdit(ji,jj,jk)*ze1ur
-                       zdxs=zdis(ji,jj,jk)*ze1ur
-
-                       ze3wr=1.0/fse3w(ji+ip,jj,jk+kp)
-                       zdzt=zdkt(ji+ip,jj,jk+kp)*ze3wr
-                       zdzs=zdks(ji+ip,jj,jk+kp)*ze3wr
-                       zslope=zsx(ji+ip,jj,jk,1-ip,kp)
-
-                       zvolf = 0.25_wp*e1u(ji,jj)*e2u(ji,jj)*fse3u(ji,jj,jk)
-
-                       ftu(ji,jj,jk)= ftu(ji,jj,jk)+zslope*zdzt*zvolf*ze1ur
-                       fsu(ji,jj,jk)= fsu(ji,jj,jk)+zslope*zdzs*zvolf*ze1ur
-                       ftud(ji,jj,jk)=ftud(ji,jj,jk)+fsahtu(ji,jj,jk)*zdxt*zvolf*ze1ur
-                       fsud(ji,jj,jk)=fsud(ji,jj,jk)+fsahtu(ji,jj,jk)*zdxs*zvolf*ze1ur
-                       tfw(ji+ip,jj,jk+kp)=tfw(ji+ip,jj,jk+kp)+(zvolf*ze3wr)*zslope*zdxt
-                       sfw(ji+ip,jj,jk+kp)=sfw(ji+ip,jj,jk+kp)+(zvolf*ze3wr)*zslope*zdxs
-                       wslp2(ji+ip,jj,jk+kp)=wslp2(ji+ip,jj,jk+kp)+ &
-                            & ((zvolf*ze3wr)/(e1t(ji+ip,jj)*e2t(ji+ip,jj)))*(zslope)**2
-                       psix_eiv(ji,jj,jk+kp) = psix_eiv(ji,jj,jk+kp) + 0.25_wp*zslope
-
-                    END DO
-                 END DO
-
-              END DO
-           END DO
-        END DO
-
-        ! ----------------------------------------------------------------------
-        ! y-z plane
-        ! ----------------------------------------------------------------------
-
-        ! calculate limited triad y-slopes zsy in interior (1=<jk=<jpk-1)
-        DO jp=0,1
-           DO kp=0,1
-
-              DO jk = 1, jpkm1
-                 DO jj = 1, jpjm1
-                    DO ji = 1, fs_jpim1   ! vector opt.
-
-                       ze2vr=1.0/e2v(ji,jj)
-                       zdyt=zdjt(ji,jj,jk)*ze2vr
-                       zdys=zdjs(ji,jj,jk)*ze2vr
-
-                       ze3wr=1.0/fse3w(ji,jj+jp,jk+kp)
-                       zdzt=zdkt(ji,jj+jp,jk+kp)*ze3wr
-                       zdzs=zdks(ji,jj+jp,jk+kp)*ze3wr
-                       ! Calculate the horizontal and vertical density gradient
-                       zdyrho = alpha(ji,jj+jp,jk)*zdyt+beta(ji,jj+jp,jk)*zdys
-                       zabs_dzrho = ABS(alpha(ji,jj+jp,jk)*zdzt+beta(ji,jj+jp,jk)*zdzs)+zepsln
-                       ! Limit by slpmax, and mask by psi-point
-                       zsy(ji,jj+jp,jk,1-jp,kp) = vmask(ji,jj,jk+kp) &
-                            & *zdyrho/MAX(zabs_dzrho,zr_slpmax*ABS(zdyrho))
-                    END DO
-                 END DO
-              END DO
-
-           END DO
-        END DO
-
-        ! calculate slope of triad immediately below mixed-layer base
-        DO jp=0,1
-           DO kp=0,1
-              DO jj = 1, jpjm1
-                 DO ji = 1, fs_jpim1
-                    jk = nmln(ji,jj+jp)
-                    zsy_ml_base(ji,jj+jp,1-jp,kp)=zsy(ji,jj+jp,jk+1-kp,1-jp,kp)
-                 END DO
-              END DO
-           END DO
-        END DO
-
-        ! Below ML use limited zsy as is
-        ! Inside ML replace by linearly reducing zsy_ml_base towards surface
-        DO jp=0,1
-           DO kp=0,1
-              DO jk = 1, jpkm1
-                 DO jj = 1, jpjm1
-                    DO ji = 1, fs_jpim1   ! vector opt.
-                       ! k index of uppermost point(s) of triad is jk+kp-1
-                       ! must be .ge. nmln(ji,jj) for zfact=1.
-                       !                   otherwise  zfact=0.
-                       zfact = 1 - 1/(1 + (jk+kp-1)/nmln(ji,jj+jp))
-                       zsy(ji,jj+jp,jk,1-jp,kp) = zfact*zsy(ji,jj+jp,jk,1-jp,kp) + &
-                           & (1.0_wp-zfact)*(fsdepw(ji,jj+jp,jk+kp)*zr_ml_basew(ji,jj+jp))*zsy_ml_base(ji,jj+jp,1-jp,kp) 
-                    END DO
-
-                 END DO
-
-              END DO
-           END DO
-        END DO
-
-        ! Use zsy to calculate fluxes and save averaged slopes psiy_eiv at psi-points
-        DO jp=0,1
-           DO kp=0,1
-              DO jk = 1, jpkm1
-                 DO jj = 1, jpjm1
-                    DO ji = 1, fs_jpim1   ! vector opt.
-
-                       ze2vr=1.0/e2v(ji,jj)
-                       zdyt=zdjt(ji,jj,jk)*ze2vr
-                       zdys=zdjs(ji,jj,jk)*ze2vr
-
-                       ze3wr=1.0/fse3w(ji,jj+jp,jk+kp)
-                       zdzt=zdkt(ji,jj+jp,jk+kp)*ze3wr
-                       zdzs=zdks(ji,jj+jp,jk+kp)*ze3wr
-                       zslope=zsy(ji,jj+jp,jk,1-jp,kp)
-
-                       zvolf = 0.25_wp*e1v(ji,jj)*e2v(ji,jj)*fse3v(ji,jj,jk)
-
-                       ftv(ji,jj,jk)= ftv(ji,jj,jk)+zslope*zdzt*zvolf*ze2vr
-                       fsv(ji,jj,jk)= fsv(ji,jj,jk)+zslope*zdzs*zvolf*ze2vr
-                       ftvd(ji,jj,jk)=ftvd(ji,jj,jk)+fsahtv(ji,jj,jk)*zdyt*zvolf*ze2vr
-                       fsvd(ji,jj,jk)=fsvd(ji,jj,jk)+fsahtv(ji,jj,jk)*zdys*zvolf*ze2vr
-                       tfw(ji,jj+jp,jk+kp)=tfw(ji,jj+jp,jk+kp)+(zvolf*ze3wr)*zslope*zdyt
-                       sfw(ji,jj+jp,jk+kp)=sfw(ji,jj+jp,jk+kp)+(zvolf*ze3wr)*zslope*zdys
-                       wslp2(ji,jj+jp,jk+kp)=wslp2(ji,jj+jp,jk+kp)+ &
-                            & ((zvolf*ze3wr)/(e1t(ji,jj+jp)*e2t(ji,jj+jp)))*(zslope)**2
-                       psiy_eiv(ji,jj,jk+kp) = psiy_eiv(ji,jj,jk+kp) + 0.25_wp*zslope
-
-                    END DO
-                 END DO
-              END DO
-           END DO
-        END DO
-
-        tfw(:,:,1)=0.e0
-        sfw(:,:,1)=0.e0
-        wslp2(:,:,1)=0.e0
-
-        CALL lbc_lnk( wslp2, 'W', 1. )
-        CALL lbc_lnk( tfw, 'W', 1. )
-        CALL lbc_lnk( sfw, 'W', 1. )
-        CALL lbc_lnk( ftu, 'U', -1. )
-        CALL lbc_lnk( fsu, 'U', -1. )
-        CALL lbc_lnk( ftv, 'V', -1. )
-        CALL lbc_lnk( fsv, 'V', -1. )
-        CALL lbc_lnk( ftud, 'U', -1. )
-        CALL lbc_lnk( fsud, 'U', -1. )
-        CALL lbc_lnk( ftvd, 'V', -1. )
-        CALL lbc_lnk( fsvd, 'V', -1. )
-        CALL lbc_lnk( psix_eiv, 'U', -1. )
-        CALL lbc_lnk( psiy_eiv, 'V', -1. )
+               iku = MAX( MIN( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1, 2 )    ! last ocean level
+               ikv = MAX( MIN( mbathy(ji,jj), mbathy(ji,jj+1  ) ) - 1, 2 )
+               zdit (ji,jj,iku) = gtsu(ji,jj,jp_tem)                          ! i-gradient of T and S
+               zdis (ji,jj,iku) = gtsu(ji,jj,jp_sal)
+               zdjt (ji,jj,ikv) = gtsv(ji,jj,jp_tem)                          ! j-gradient of T and S
+               zdjs (ji,jj,ikv) = gtsv(ji,jj,jp_sal)
+            END DO
+         END DO
+      ENDIF
+      !
+      zdkt(:,:,1) = 0._wp                    !==  before vertical T & S gradient at w-level  ==!
+      zdks(:,:,1) = 0._wp
+      DO jk = 2, jpk
+         zdkt(:,:,jk) = ( tb(:,:,jk-1) - tb(:,:,jk) ) * tmask(:,:,jk)
+         zdks(:,:,jk) = ( sb(:,:,jk-1) - sb(:,:,jk) ) * tmask(:,:,jk)
+      END DO
+      !
+      !
+      DO jl = 0, 1                           !==  density i-, j-, and k-gradients  ==!
+         ip = jl   ;   jp = jl         ! guaranteed nonzero gradients ( absolute value larger than repsln)
+         DO jk = 1, jpkm1                          ! done each pair of triad
+            DO jj = 1, jpjm1                       ! NB: not masked due to the minimum value set
+               DO ji = 1, fs_jpim1   ! vector opt. 
+                  zdxrho_raw = ( zalpha(ji+ip,jj   ,jk) * zdit(ji,jj,jk) + zbeta(ji+ip,jj   ,jk) * zdis(ji,jj,jk) ) / e1u(ji,jj)
+                  zdyrho_raw = ( zalpha(ji   ,jj+jp,jk) * zdjt(ji,jj,jk) + zbeta(ji   ,jj+jp,jk) * zdjs(ji,jj,jk) ) / e2v(ji,jj)
+                  zdxrho(ji+ip,jj   ,jk,1-ip) = SIGN( MAX(   repsln, ABS( zdxrho_raw ) ), zdxrho_raw )    ! keep the sign
+                  zdyrho(ji   ,jj+jp,jk,1-jp) = SIGN( MAX(   repsln, ABS( zdyrho_raw ) ), zdyrho_raw )
+               END DO
+            END DO
+         END DO
+      END DO
+     DO kp = 0, 1                           !==  density i-, j-, and k-gradients  ==!
+         DO jk = 1, jpkm1                          ! done each pair of triad
+            DO jj = 1, jpj                       ! NB: not masked due to the minimum value set
+               DO ji = 1, jpi   ! vector opt. 
+                   zdzrho_raw = ( zalpha(ji,jj,jk) * zdkt(ji,jj,jk+kp) + zbeta(ji,jj,jk) * zdks(ji,jj,jk+kp) )   &
+                     &       / fse3w(ji,jj,jk+kp)
+                  zdzrho(ji   ,jj   ,jk,  kp) =     - MIN( - repsln,      zdzrho_raw )                    ! force zdzrho >= repsln
+               END DO
+            END DO
+         END DO
+      END DO
+      !
+      DO jj = 1, jpj                         !==  Reciprocal depth of the w-point below ML base  ==!
+         DO ji = 1, jpi                            ! i.e. 1 / (hmld+e3t(nmln))  where hmld=depw(nmln)
+            jk = MIN( nmln(ji,jj), mbathy(ji,jj) - 1 ) + 1     ! MIN in case ML depth is the ocean depth
+            z1_mlbw(ji,jj) = 1._wp / fsdepw(ji,jj,jk)
+         END DO
+      END DO
+      !
+      !                                      !==  intialisations to zero  ==!
+      !
+      wslp2  (:,:,:)     = 0._wp                                           ! wslp2 will be cumulated 3D field set to zero
+      triadi_g(:,:,1,:,:) = 0._wp   ;   triadi_g(:,:,jpk,:,:) = 0._wp        ! set surface and bottom slope to zero
+      triadj_g(:,:,1,:,:) = 0._wp   ;   triadj_g(:,:,jpk,:,:) = 0._wp
+!!gm _iso set to zero missing
+      triadi (:,:,1,:,:) = 0._wp   ;   triadj (:,:,jpk,:,:) = 0._wp        ! set surface and bottom slope to zero
+      triadj (:,:,1,:,:) = 0._wp   ;   triadj (:,:,jpk,:,:) = 0._wp
+      
+      !-------------------------------------!
+      !  Triads just below the Mixed Layer  !
+      !-------------------------------------!
+      !
+      DO jl = 0, 1               ! calculate slope of the 4 triads immediately ONE level below mixed-layer base
+         DO kp = 0, 1            ! with only the slope-max limit   and   MASKED 
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1
+                  ip = jl   ;   jp = jl
+                  jk = MIN( nmln(ji+ip,jj), mbathy(ji+ip,jj) - 1 ) + 1     ! ML level+1 (MIN in case ML depth is the ocean depth)
+                  zti_g_raw = (  zdxrho(ji+ip,jj,jk-kp,1-ip) / zdzrho(ji+ip,jj,jk-kp,kp)      &
+                     &      + ( fsdept(ji+1,jj,jk-kp) - fsdept(ji,jj,jk-kp) ) / e1u(ji,jj)  ) * umask(ji,jj,jk)
+                  jk = MIN( nmln(ji,jj+jp), mbathy(ji,jj+jp) - 1 ) + 1
+                  ztj_g_raw = (  zdyrho(ji,jj+jp,jk-kp,1-jp) / zdzrho(ji,jj+jp,jk-kp,kp)      &
+                     &      + ( fsdept(ji,jj+1,jk-kp) - fsdept(ji,jj,jk-kp) ) / e2v(ji,jj)  ) * vmask(ji,jj,jk)
+                  zti_mlb(ji+ip,jj   ,1-ip,kp) = SIGN( MIN( rn_slpmax, ABS( zti_g_raw ) ), zti_g_raw )
+                  ztj_mlb(ji   ,jj+jp,1-jp,kp) = SIGN( MIN( rn_slpmax, ABS( ztj_g_raw ) ), ztj_g_raw )
+               END DO
+            END DO
+         END DO
+      END DO
+
+      !-------------------------------------!
+      !  Triads with surface limits         !
+      !-------------------------------------!
+      !
+      DO kp = 0, 1                        ! k-index of triads
+         DO jl = 0, 1
+            ip = jl   ;   jp = jl         ! i- and j-indices of triads (i-k and j-k planes)
+            DO jk = 1, jpkm1
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1   ! vector opt.
+                     !
+                     ! Calculate slope relative to geopotentials used for GM skew fluxes
+                     ! For s-coordinate, subtract slope at t-points (equivalent to *adding* gradient of depth)
+                     ! Limit by slope *relative to geopotentials* by rn_slpmax, and mask by psi-point
+                     ! masked by umask taken at the level of dz(rho)
+                     !
+                     ! raw slopes: unmasked unbounded slopes (relative to geopotential (zti_g) and model surface (zti)
+                     !
+                     zti_raw   = zdxrho(ji+ip,jj   ,jk,1-ip) / zdzrho(ji+ip,jj   ,jk,kp)                   ! unmasked
+                     ztj_raw   = zdyrho(ji   ,jj+jp,jk,1-jp) / zdzrho(ji   ,jj+jp,jk,kp)
+                     zti_coord = ( fsdept(ji+1,jj  ,jk) - fsdept(ji,jj,jk) ) / e1u(ji,jj)
+                     ztj_coord = ( fsdept(ji  ,jj+1,jk) - fsdept(ji,jj,jk) ) / e2v(ji,jj)
+                  ! unmasked
+                     zti_g_raw = zti_raw + zti_coord      ! ref to geopot surfaces
+                     ztj_g_raw = ztj_raw + ztj_coord
+                     zti_g_lim = SIGN( MIN( rn_slpmax, ABS( zti_g_raw ) ), zti_g_raw )
+                     ztj_g_lim = SIGN( MIN( rn_slpmax, ABS( ztj_g_raw ) ), ztj_g_raw )
+                     !
+                     ! Below  ML use limited zti_g as is
+                     ! Inside ML replace by linearly reducing sx_mlb towards surface
+                     !
+                     zfacti = REAL( 1 - 1/(1 + (jk+kp-1)/nmln(ji+ip,jj)), wp )  ! k index of uppermost point(s) of triad is jk+kp-1
+                     zfactj = REAL( 1 - 1/(1 + (jk+kp-1)/nmln(ji,jj+jp)), wp )  ! must be .ge. nmln(ji,jj) for zfact=1
+                     !                                                          !                   otherwise  zfact=0
+                     zti_g_lim =           zfacti   * zti_g_lim                       &
+                        &      + ( 1._wp - zfacti ) * zti_mlb(ji+ip,jj,1-ip,kp)   &
+                        &                           * fsdepw(ji+ip,jj,jk+kp) * z1_mlbw(ji+ip,jj)
+                     ztj_g_lim =           zfactj   * ztj_g_lim                       &
+                        &      + ( 1._wp - zfactj ) * ztj_mlb(ji,jj+jp,1-jp,kp)   &
+                        &                           * fsdepw(ji,jj+jp,jk+kp) * z1_mlbw(ji,jj+jp)                   ! masked
+                     !
+                     triadi_g(ji+ip,jj   ,jk,1-ip,kp) = zti_g_lim * umask(ji,jj,jk+kp)
+                     triadj_g(ji   ,jj+jp,jk,1-jp,kp) = ztj_g_lim * vmask(ji,jj,jk+kp)
+                     !
+                     ! Get coefficients of isoneutral diffusion tensor
+                     ! 1. Utilise gradients *relative* to s-coordinate, so add t-point slopes (*subtract* depth gradients)
+                     ! 2. We require that isoneutral diffusion  gives no vertical buoyancy flux
+                     !     i.e. 33 term = (real slope* 31, 13 terms)
+                     ! To do this, retain limited sx**2  in vertical flux, but divide by real slope for 13/31 terms
+                     ! Equivalent to tapering A_iso = sx_limited**2/(real slope)**2
+                     !
+                     zti_lim  = zti_g_lim - zti_coord    ! remove the coordinate slope  ==> relative to coordinate surfaces
+                     ztj_lim  = ztj_g_lim - ztj_coord                                 
+                     zti_lim2 = zti_lim * zti_lim * umask(ji,jj,jk+kp)      ! square of limited slopes            ! masked <<==
+                     ztj_lim2 = ztj_lim * ztj_lim * vmask(ji,jj,jk+kp)
+                     !
+                     zbu = e1u(ji    ,jj) * e2u(ji   ,jj) * fse3u(ji   ,jj,jk   )
+                     zbv = e1v(ji    ,jj) * e2v(ji   ,jj) * fse3v(ji   ,jj,jk   )
+                     zbti = e1t(ji+ip,jj) * e2t(ji+ip,jj) * fse3w(ji+ip,jj,jk+kp)
+                     zbtj = e1t(ji,jj+jp) * e2t(ji,jj+jp) * fse3w(ji,jj+jp,jk+kp)
+                     !
+                     triadi(ji+ip,jj   ,jk,1-ip,kp) = zti_lim2 / zti_raw                                          ! masked
+                     triadj(ji   ,jj+jp,jk,1-jp,kp) = ztj_lim2 / ztj_raw
+                     !
+!!gm this may inhibit vectorization on Vect Computers, and even on scalar computers....  ==> to be checked
+                     wslp2 (ji+ip,jj,jk+kp) = wslp2(ji+ip,jj,jk+kp) + 0.25_wp * zbu / zbti * zti_lim2             ! masked
+                     wslp2 (ji,jj+jp,jk+kp) = wslp2(ji,jj+jp,jk+kp) + 0.25_wp * zbv / zbtj * ztj_lim2
+                  END DO
+               END DO
+            END DO
+         END DO
+      END DO
+      !
+      wslp2(:,:,1) = 0._wp                ! force the surface wslp to zero
+      
+      CALL lbc_lnk( wslp2, 'W', 1. )      ! lateral boundary confition on wslp2 only   ==>>> gm : necessary ? to be checked
       !
    END SUBROUTINE ldf_slp_grif
